'Tank Commander (C) 1999 William Denniss, Final Version (Revised)
'PLEASE NOTE:  The author of Tank Commander (William Denniss) has released its source code.
'You may use this for what ever you want, so long as the original author is recognised.  It is a small thing to ask, but an important issue, as the author has spent a lot of time designing this program.
'Thank you in advance for your cooperation

DECLARE FUNCTION shoot! (xstart AS INTEGER, ystart AS INTEGER, angle AS INTEGER, power AS INTEGER, wind AS INTEGER, gravity AS INTEGER, weapon AS STRING, terraincolour AS INTEGER, tank1xpos AS INTEGER, tank1ypos AS INTEGER, tank2xpos AS INTEGER,  _
tank2ypos AS INTEGER, tank3xpos AS INTEGER, tank3ypos AS INTEGER, tank4xpos AS INTEGER, tank4ypos AS INTEGER, tank1status AS INTEGER, tank2status AS INTEGER, tank3status AS INTEGER, tank4status AS INTEGER, types AS INTEGER, first AS INTEGER, last AS _
 INTEGER)
DECLARE SUB locatecol (row AS INTEGER, column AS INTEGER, sentence AS STRING, colors AS INTEGER)
DECLARE SUB circlefill (x AS INTEGER, y AS INTEGER, radias AS INTEGER, colour AS INTEGER)
DECLARE FUNCTION getkey$ ()
DECLARE SUB capsoff ()
DECLARE SUB armmove (angle AS INTEGER, x AS INTEGER, y AS INTEGER, colour AS INTEGER)
DECLARE FUNCTION terrainpxltest! (x AS INTEGER, y AS INTEGER)
DECLARE SUB box (xi AS INTEGER, yi AS INTEGER, xf AS INTEGER, yf AS INTEGER, boxwidth AS INTEGER, boardercolour AS INTEGER, fillcolour AS INTEGER)
DECLARE FUNCTION windmake! (maximumwind AS STRING)
DECLARE SUB winddraw (wind AS INTEGER)
DECLARE SUB tankdraw (angle AS INTEGER, x AS INTEGER, y AS INTEGER, colour AS INTEGER)
DECLARE SUB planedraw (x AS INTEGER, y AS INTEGER, colour AS INTEGER)
DECLARE FUNCTION symbols$ (ky AS STRING)
DECLARE FUNCTION nameinput$ (initplace AS INTEGER, row AS INTEGER, initname AS STRING, max AS INTEGER)


TYPE tanktype
  rounds AS INTEGER
  filename AS STRING * 21
  xpos AS INTEGER
  ypos AS INTEGER
  angle AS INTEGER
  power AS INTEGER
  status AS INTEGER
  tname AS STRING * 21
  ttype AS STRING * 10
  weapon AS STRING * 9
  smartness AS STRING * 10
  score AS INTEGER
  scores AS STRING * 3
  totalscore AS INTEGER
  col AS INTEGER
END TYPE

  DIM file AS tanktype
  DIM totalplayerstmp AS INTEGER
  DIM turnold AS INTEGER
  DIM first AS INTEGER
  DIM last AS INTEGER
  DIM num AS INTEGER
  DIM stat(1 TO 4) AS INTEGER
  DIM initial AS INTEGER
  DIM I AS INTEGER
  DIM tank(1 TO 4) AS tanktype
  DIM tankold(1 TO 4) AS tanktype
  DIM tmpstatus(1 TO 4) AS INTEGER
  DIM a AS DOUBLE
  DIM groundcolour AS INTEGER, terrainver AS INTEGER, terrainhor AS INTEGER
  DIM keypress AS STRING
  DIM asckeypress AS INTEGER
  DIM gravity AS STRING
  DIM maxwind AS STRING
  DIM planes AS STRING
  DIM terrainheight AS STRING
  DIM terraincolor AS STRING
  DIM totalscore(1 TO 4, 1 TO 2) AS STRING
  DIM totalscoreint(1 TO 4) AS INTEGER
  DIM done(1 TO 4) AS INTEGER
  DIM usesenario AS INTEGER
  DIM filenum(1 TO 11) AS INTEGER
  DIM ingame AS STRING
  DIM turn AS INTEGER
  DIM points AS STRING
  DIM tmpname AS STRING
  DIM wind AS INTEGER
  DIM weapon AS STRING
  DIM angle, rename AS INTEGER
  DIM power AS INTEGER
  DIM neumericgravity AS INTEGER
  DIM menuplace AS INTEGER
  DIM ky AS STRING
  DIM tankname AS STRING
  DIM tanktype AS STRING
  DIM ai AS STRING
  DIM smartness AS STRING
  DIM query AS INTEGER
  DIM tankx AS INTEGER
  DIM tanky AS INTEGER
  DIM tnkexplode AS INTEGER
  DIM rounds AS INTEGER
  DIM planeweapon AS STRING
  DIM bomb AS INTEGER
  DIM K AS INTEGER
  DIM tmpcol AS INTEGER
  DIM filename(1 TO 11)  AS STRING
  DIM totalplayers AS INTEGER
  
  DIM tmp AS INTEGER
  DIM flight AS INTEGER
  DIM humans AS INTEGER
  DIM watch AS INTEGER
  DIM rannum(1 TO 4) AS INTEGER
  DIM numsmart AS INTEGER
  DIM numaverage AS INTEGER
  DIM numkiller AS INTEGER
  DIM numstupid AS INTEGER
  DIM recentflight AS INTEGER
  DIM exited AS INTEGER
  DIM oldrounds AS INTEGER
  DIM heading AS STRING
  DIM xstop AS INTEGER
  DIM rndnum(2 TO 4) AS INTEGER
      
  CONST enter = 13, Escape = 27, Space = 32, Backspace = 8
  CONST Downarrow = 80, Uparrow = 72, Leftarrow = 75, Rightarrow = 77
  CONST excl = 33, andsign = 36, asterisk = 42, hyphen = 45, comma = 44
  CONST hash = 35, percent = 37, dollar = 36, attherateof = 64, hat = 94, apostraphy = 39, brac1 = 40, brac2 = 41, colon = 58
  CONST fullstop = 46, lessthan = 60, greaterthan = 62, square1 = 91, square2 = 93, curv1 = 123, curv2 = 125, plus = 43, underline = 95, equal = 61
  CONST backslash = 92, forardslash = 47, verticleline = 124, semicolon = 59, quotations = 34, question = 63
   

  RANDOMIZE TIMER
  SCREEN 12

'initialise vareables
  terraincolor = "random"
  terrainheight = "mountainous"
  planes = "rare"
  gravity = "Earth"
  weapon = "Missile  "
  maxwind = "windy"
  ingame = "no"

  turn = 1
  flight = 1
  tank(1).tname = ""
  tank(2).tname = ""
  tank(3).tname = ""
  tank(4).tname = ""
  tank(1).col = 4
  tank(2).col = 1
  tank(3).col = 5
  tank(4).col = 14
    'color
  exited = 0
  menuplace = 1
'---------------Menu
menustart:
  IF rounds = 0 THEN ingame = "no"
  rename = 0
  IF exited = 1 THEN
    IF oldrounds <> 0 THEN
      FOR I = 1 TO 4
        rounds = oldrounds
        tank(I).totalscore = tankold(I).totalscore
        tank(I).angle = tankold(I).angle
        tank(I).power = tankold(I).power
        tank(I).weapon = tankold(I).weapon
        tank(I).score = tankold(I).score
        tank(I).scores = tankold(I).scores
        tank(I).totalscore = tankold(I).totalscore
      NEXT I
      ingame = "yes"
    ELSE
      ingame = "no"
    END IF
  END IF
  TIMER OFF
 
 
  FOR I = 1 TO 4
    tank(I).power = 65
  NEXT I
  query = 1
  terraincolour = INT(2 * RND + 1)
  IF terraincolour = 1 THEN terraincolour = 6
  number = 480
  numb = 2
  GOSUB drawterrain
  IF ingame = "yes" THEN
    CALL box(290, 100, 600, 350, 10, 4, 0)
   
    FOR I = 1 TO 4
      
      SELECT CASE tank(I).score
        CASE 1
          tank(I).scores = "1st"
        CASE 2
          tank(I).scores = "2nd"
        CASE 3
          tank(I).scores = "3rd"
        CASE 4
          tank(I).scores = "4th"
      END SELECT
    NEXT I

    CALL locatecol(8, 42, "Round", 1)
    CALL locatecol(8, 48 + LEN(STR$(rounds)), "results", 1)

  COLOR 4: LOCATE 8, 47: PRINT rounds
    FOR I = 10 TO 13
        FOR K = 1 TO 4
          IF RTRIM$(tank(K).ttype) <> "off" AND tank(K).score = I - 9 THEN
            CALL locatecol(I, 40, tank(K).scores, 4)
            CALL locatecol(I, 44, "Tank", 1)
            LOCATE I, 48: PRINT K
            CALL locatecol(I, 50, ",", 1)
            CALL locatecol(I, 52, RTRIM$(tank(K).tname), 4)
          END IF
        NEXT K
    NEXT I
   
    CALL locatecol(15, 42, "Total Score", 1)

    FOR I = 1 TO 4
      IF RTRIM$(tank(I).ttype) <> "off" THEN totalscoreint(I) = tank(I).totalscore ELSE totalscoreint(I) = -1
      done(I) = 0
    NEXT I

'sort totalscoreint desending
    FOR I = 1 TO 3
      FOR K = I + 1 TO 4
        IF totalscoreint(I) < totalscoreint(K) THEN
          tmp = totalscoreint(K)
          totalscoreint(K) = totalscoreint(I)
          totalscoreint(I) = tmp
        END IF
      NEXT K
    NEXT I
   
    FOR I = 1 TO 4
      FOR K = 1 TO 4
        IF tank(K).totalscore = totalscoreint(I) AND done(K) = 0 THEN
          totalscore(I, 1) = "Tank" + STR$(K) + ", "
          totalscore(I, 2) = RTRIM$(tank(K).tname) + " " + STR$(totalscoreint(I))
          done(K) = 1
          IF RTRIM$(tank(K).ttype) = "off" THEN
            totalscore(I, 1) = ""
            totalscore(I, 2) = ""
          END IF
          EXIT FOR
        END IF
      NEXT K
    NEXT I
   
    FOR I = 17 TO 20
      CALL locatecol(I, 40, totalscore(I - 16, 1), 1)
      CALL locatecol(I, 48, totalscore(I - 16, 2), 4)

    NEXT I

  END IF
  IF rounds > 9999 THEN rounds = 9999

menu:
  CALL box(10, 10, 180, 210, 10, 4, 0)
  CALL box(300, 15, 550, 80, 10, 4, 0)       'color
  CALL locatecol(4, 42, "(C) 1998 William Denniss", 1)
  CALL locatecol(3, 47, "Tank Commander", 1)

menu2:

  CALL locatecol(3, 4, "    MAIN MENU    ", 4)
  DO
    IF ingame = "yes" THEN tmpcol = 1 ELSE tmpcol = 8
   
    CALL locatecol(5, 6, "  New Game   ", 1)
    CALL locatecol(6, 6, "  Rename     ", tmpcol + 0)
    CALL locatecol(7, 6, "  Continue   ", tmpcol + 0)
    CALL locatecol(8, 6, "  Save Game  ", tmpcol + 0)
    CALL locatecol(9, 6, "  Load Game  ", 1)
    CALL locatecol(10, 6, "  Options    ", 1)
    CALL locatecol(11, 6, "  Exit       ", 1)
    IF menuplace = 1 THEN CALL locatecol(5, 6, "< New Game  >", 4)
    IF menuplace = 2 THEN CALL locatecol(6, 6, "< Rename    >", 4)
    IF menuplace = 3 THEN CALL locatecol(7, 6, "< Continue  >", 4)
    IF menuplace = 4 THEN CALL locatecol(8, 6, "< Save Game >", 4)
    IF menuplace = 5 THEN CALL locatecol(9, 6, "< Load Game >", 4)
    IF menuplace = 6 THEN CALL locatecol(10, 6, "< Options   >", 4)
    IF menuplace = 7 THEN CALL locatecol(11, 6, "< Exit      >", 4)
    TIMER ON
    ON TIMER(30) GOSUB SS
    FOR I = 1 TO 30
      ky = INKEY$
    NEXT I
    DO
      ky = getkey
      IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
    LOOP UNTIL ky = "right" OR ky = "left" OR ky = "enter" OR ky = "up" OR ky = "down" OR ky = "escape"
    TIMER OFF
    IF ky = "left" OR ky = "up" THEN
      menuplace = menuplace - 1
      IF ingame = "no" THEN
        IF menuplace >= 2 AND menuplace <= 4 THEN menuplace = 1
      END IF

    END IF
    IF ky = "right" OR ky = "down" THEN
      menuplace = menuplace + 1
      IF ingame = "no" THEN
        IF menuplace >= 2 AND menuplace <= 4 THEN menuplace = 5
      END IF
    END IF
    IF menuplace = 0 THEN menuplace = 7
    IF menuplace = 8 THEN menuplace = 1
    IF ky = "escape" THEN menuplace = 7
  LOOP UNTIL ky = "enter"
  IF menuplace = 3 AND ingame = "yes" THEN
    GOTO inplay
  END IF
  IF menuplace = 7 THEN
    CALL box(10, 10, 180, 210, 10, 4, 0)
    CALL locatecol(3, 6, "Exit to System?", 1)
    CALL locatecol(4, 9, "Yes   > No", 4)
    ans = 0
    DO
      ky = getkey
      IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      IF ky = "left" OR ky = "right" OR ky = "up" OR ky = "down" THEN
        IF ans = 0 THEN
          ans = 1
        ELSE
          ans = 0
        END IF
      END IF
      IF ans = 0 THEN CALL locatecol(4, 7, "  Yes   > No", 4)
      IF ans = 1 THEN CALL locatecol(4, 7, "> Yes     No", 4)
    LOOP UNTIL ky = "y" OR ky = "n" OR ky = "enter" OR ky = "escape"
    IF ky = "y" OR ans = 1 THEN
      SCREEN 0
      CALL locatecol(1, 1, "Thank you for playing Tank Commander (C) 1998 William Denniss", 1)
      END
    ELSE
      CALL locatecol(4, 7, "            ", 0)
      menuplace = 7
      GOTO menu2
    END IF
  END IF

'** Rename code
  IF menuplace = 2 THEN
    
    rename = 1
    GOSUB tanknamemenu
    menuplace = 2
    GOTO menustart
  END IF

        '###########***********  LOAD AND SAVE MENU  ###########***********
  IF menuplace >= 4 AND menuplace <= 5 THEN
    LINE (0, 0)-(640, 480), 9, BF
    FOR I = 1 TO 5
      CALL tankdraw(INT(180 * RND), INT(639 * RND + 1), INT(70 * RND + 410), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(639 * RND + 1), INT(95 * RND - 10), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(100 * RND - 10), INT(330 * RND + 80), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(110 * RND + 530), INT(330 * RND + 80), INT(14 * RND + 1))
    NEXT I
  
    CALL box(100, 80, 540, 370, 10, 4, 0)
    SELECT CASE menuplace
      CASE 4
        heading = "Save Game"
      CASE 5
        heading = "Load Game"
    END SELECT
    menuplace = 1
    exited = 0

reloadfiles:
    
    CLOSE
    tmpcol = 4
    FOR I = 1 TO 10
      filenum(I) = FREEFILE
      filename(I) = "tcsave" + LTRIM$(STR$(I)) + ".sav"
      
      OPEN filename(I) FOR RANDOM AS filenum(I) LEN = LEN(tank(1))
      numrecs = LOF(filenum(I)) \ LEN(tank(1))
      GET filenum(I), 1, file
      IF RTRIM$(file.filename) = "" OR numrecs = 0 THEN
        file.filename = "Save File " + LTRIM$(STR$(I))
        PUT filenum(I), 1, file
      END IF
      filename(I) = file.filename
                                    
      
      CALL locatecol(I + 10, 20, file.filename, 1) 'no rtrim to erase previous in the event of a corruption
    NEXT I
    CALL locatecol(8, 17, heading, 4)
    CALL locatecol(9, 40, "Press Esc to exit", 14)
    initial = 1
    menuplace = menuplace + 1
    DO
      IF initial = 1 THEN 'see if first file has no data
        ky = "up"
        
      ELSE
        ky = getkey
        IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      END IF
      IF ky = "escape" THEN
        IF heading = "Save Game" THEN menuplace = 4 ELSE menuplace = 5
        GOTO menustart
      END IF
      IF ky = "left" OR ky = "up" THEN menuplace = menuplace - 1
      IF ky = "right" OR ky = "down" THEN menuplace = menuplace + 1
      IF menuplace = 0 THEN menuplace = 10
      IF menuplace = 11 THEN menuplace = 1
      IF ky = "down" OR ky = "up" OR ky = "left" OR ky = "right" THEN
        filenum(11) = FREEFILE
        filename(11) = "tcsave" + LTRIM$(STR$(menuplace)) + ".sav"
        OPEN filename(11) FOR RANDOM AS filenum(11) LEN = LEN(tank(1))
        GET filenum(11), 1, tankold(1)
        oldrounds = tankold(1).rounds
        IF tankold(1).col = 0 THEN CALL locatecol(22, 20, "No data in file!", 14) ELSE CALL locatecol(22, 20, "                ", 14)
        CLOSE filenum(11)
     
      END IF
      IF initial = 0 THEN
        FOR I = 1 TO 10
          CALL locatecol(I + 10, 18, " ", 4)
        NEXT I
      ELSE
        initial = 0
      END IF
      IF menuplace > 10 THEN CALL locatecol(menuplace + 11, 18, ">", 4) ELSE CALL locatecol(menuplace + 10, 18, ">", 4)
      IF ky = "enter" AND heading = "Load Game" THEN
       
        CALL box(123, 200, 515, 260, 10, 4, 0)
        CALL locatecol(15, 19, "Are you sure you want to load this game? Y/N", 1)
        DO
          ky = getkey
          IF ky = "escape" THEN ky = "n"
        LOOP UNTIL ky = "n" OR ky = "y"
        IF ky = "n" THEN
          LINE (123, 200)-(515, 260), 0, BF
          'menuplace = menuplace + 1
          GOTO reloadfiles
        END IF
        GET filenum(menuplace), 1, tankold(1)
        GET filenum(menuplace), 2, tankold(2)
        GET filenum(menuplace), 3, tankold(3)
        GET filenum(menuplace), 4, tankold(4)
        oldrounds = tankold(1).rounds
        ingame = "yes"
        IF tankold(1).col = 0 THEN
          CALL locatecol(15, 19, "                No data in file!             ", 1)
          SLEEP 1
          LINE (123, 200)-(515, 260), 0, BF
          GOTO reloadfiles
        END IF
       
        
        IF oldrounds > 0 AND oldrounds < 9999 AND INT(oldrounds) = oldrounds THEN
          CALL locatecol(15, 19, "               Game Loaded!                 ", 1)
         
          tmp = 0
          FOR I = 1 TO 4
            IF tankold(I).ttype <> "off" THEN tmp = tmp + 1
            IF RTRIM$(tankold(I).ttype) <> "off" AND RTRIM$(tankold(I).ttype) <> "human" AND RTRIM$(tankold(I).ttype) <> "computer" THEN GOTO corrupt
          NEXT I
          IF tmp < 2 OR tmp > 4 THEN GOTO corrupt
          FOR I = 1 TO 4
            IF tankold(I).weapon <> "Missile  " AND tankold(I).weapon <> "Terraform" THEN GOTO corrupt
            IF RTRIM$(tankold(I).smartness) <> "average" AND RTRIM$(tankold(I).smartness) <> "smart" AND RTRIM$(tank(I).smartness) <> "stupid" THEN GOTO corrupt
          NEXT I
         
          tank(1) = tankold(1)
          tank(2) = tankold(2)
          tank(3) = tankold(3)
          tank(4) = tankold(4)
          rounds = oldrounds
          totalplayers = 0
          FOR I = 1 TO 4
            IF tank(I).ttype <> "off" THEN totalplayers = totalplayers + 1
          NEXT
          
          
       
        ELSE
corrupt:
          CALL locatecol(15, 19, "               File Corrupt!                ", 1)
          tmpname = "tcsave" + LTRIM$(STR$(menuplace)) + ".sav"
          CLOSE filenum(menuplace)
          KILL tmpname
          SLEEP 1
          LINE (123, 200)-(515, 260), 0, BF
          GOTO reloadfiles
        END IF
        SLEEP 1
        exited = 1
      END IF
     
      IF ky = "enter" AND heading = "Save Game" THEN
        
        GET filenum(menuplace), 1, file
        CALL locatecol(menuplace + 10, 20, RTRIM$(file.filename), 4)
        tmpname = RTRIM$(file.filename)
        tmpname = nameinput(20, menuplace + 10, RTRIM$(filename(menuplace)), 21)
        IF MID$(tmpname, LEN(tmpname), 1) = "\" THEN
          CALL locatecol(menuplace + 10, 20, "                      ", 0)
          CALL locatecol(menuplace + 10, 20, file.filename, 4)
          GOTO dontsave
        ELSE
          file.filename = tmpname
        END IF
        CALL box(170, 200, 486, 260, 10, 4, 0)
        CALL locatecol(15, 25, "Are you sure you want to save? Y/N", 1)
        DO
          ky = getkey
          IF ky = "escape" THEN ky = "n"
        LOOP UNTIL ky = "n" OR ky = "y"
        IF ky = "n" THEN
          LINE (170, 200)-(486, 260), 0, BF
          GOTO reloadfiles
        END IF
        CALL locatecol(15, 25, "            Game Saved!           ", 1)
        tank(1).filename = file.filename
        tank(1).rounds = rounds
        PUT filenum(menuplace), 1, tank(1)
        PUT filenum(menuplace), 2, tank(2)
        PUT filenum(menuplace), 3, tank(3)
        PUT filenum(menuplace), 4, tank(4)
        SLEEP 1
        
        exited = 1
dontsave:
        CALL locatecol(menuplace + 10, 20, file.filename, 1)
     
      END IF
    LOOP WHILE exited = 0
    exited = 0
    IF heading = "Save Game" THEN menuplace = 4 ELSE menuplace = 5
    GOTO menustart
  END IF
   IF menuplace = 6 THEN
options:
    LINE (10, 180)-(180, 210), 9, BF
    CALL box(10, 10, 280, 180, 10, 4, 0)
    CALL locatecol(3, 7, "OPTIONS", 4)
    menuplace = 1
    ky = "up" 'activate menu print the first time
    DO
    DO
      IF ky = "up" OR ky = "down" OR ky = "left" OR ky = "right" THEN
        CALL locatecol(5, 4, "  Gravity:", 1)
        CALL locatecol(6, 4, "  Maximum Wind:", 1)
        CALL locatecol(7, 4, "  Plane Occurences:", 1)
        CALL locatecol(8, 4, "  Terrain Height:", 1)
        CALL locatecol(9, 4, "  Terrain Colour:", 1)
        CALL locatecol(10, 4, "  Exit", 1)
        CALL locatecol(5, 16, gravity, 4)
        CALL locatecol(6, 21, maxwind, 4)
        CALL locatecol(7, 25, planes, 4)
        CALL locatecol(8, 23, terrainheight, 4)
        CALL locatecol(9, 23, terraincolor, 4)
        CALL locatecol(menuplace + 4, 4, ">", 4)
      END IF
      ky = getkey
      IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      IF ky = "left" OR ky = "up" THEN menuplace = menuplace - 1
      IF ky = "right" OR ky = "down" THEN menuplace = menuplace + 1
      IF menuplace = 0 THEN menuplace = 6
      IF menuplace = 7 THEN menuplace = 1
      IF ky = "escape" THEN
        menuplace = 6
        ky = "enter"
      END IF
    LOOP UNTIL ky = "enter"
    IF menuplace = 1 THEN
      SELECT CASE gravity
        CASE "Moon"
          gravity = "Earth"
        CASE "Earth"
          gravity = "Jupiter"
        CASE "Jupiter"
          gravity = "Moon"
      END SELECT
      CALL locatecol(5, 16, "       ", 0)
      CALL locatecol(5, 16, gravity, 4)

    END IF
   
    IF menuplace = 2 THEN
      SELECT CASE maxwind
        CASE "no wind"
          maxwind = "gusty"
        CASE "gusty"
          maxwind = "windy"
        CASE "windy"
          maxwind = "stormy"
        CASE "stormy"
          maxwind = "no wind"
      END SELECT
        CALL locatecol(6, 21, "       ", 0)
        CALL locatecol(6, 21, maxwind, 4)
      
    END IF
   
   
    IF menuplace = 3 THEN
      SELECT CASE planes
        CASE "never"
          planes = "rare"
        CASE "rare"
          planes = "sometimes"
        CASE "sometimes"
          planes = "never"
      END SELECT
      CALL locatecol(7, 25, "         ", 0)
      CALL locatecol(7, 25, planes, 4)

    END IF
     
    IF menuplace = 4 THEN
      SELECT CASE terrainheight
        CASE "rocky"
          terrainheight = "hilly"
        CASE "hilly"
          terrainheight = "mountainous"
        CASE "mountainous"
          terrainheight = "alpine"
        CASE "alpine"
          terrainheight = "rocky"
      END SELECT
      CALL locatecol(8, 23, "           ", 0)
      CALL locatecol(8, 23, terrainheight, 4)
    END IF

    IF menuplace = 5 THEN
        SELECT CASE terraincolor
          CASE "random"
            terraincolor = "green"
          CASE "green"
            terraincolor = "brown"
          CASE "brown"
            terraincolor = "random"
        END SELECT
      CALL locatecol(9, 23, "      ", 0)
      CALL locatecol(9, 23, terraincolor, 4)
      
    END IF

    IF menuplace = 6 THEN
      LINE (181, 10)-(280, 180), 9, BF
      CALL box(10, 10, 180, 210, 10, 4, 0)
      menuplace = 6
      GOTO menu2
    END IF
  LOOP WHILE ky <> "escape"
  menuplace = 6
  END IF
  IF menuplace = 1 THEN

tanknamemenu:

   first = 1 'only print stuff upon loading

   ON TIMER(30) GOSUB 0
    'draw random tanks
    LINE (0, 0)-(640, 480), 9, BF
    FOR I = 1 TO 5
      CALL tankdraw(INT(180 * RND), INT(639 * RND + 1), INT(70 * RND + 410), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(639 * RND + 1), INT(95 * RND - 10), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(100 * RND - 10), INT(330 * RND + 80), INT(14 * RND + 1))
      CALL tankdraw(INT(180 * RND), INT(110 * RND + 530), INT(330 * RND + 80), INT(14 * RND + 1))
    NEXT I
     
    CALL box(100, 80, 540, 400, 10, 4, 0)
   
    
    IF RTRIM$(tank(1).tname) = "" THEN tank(1).tname = "Will"
    DO
      FOR I = 2 TO 4
        rndnum(I) = INT(44 * RND + 1)
      NEXT I
    LOOP UNTIL rndnum(2) <> rndnum(3) AND rndnum(3) <> rndnum(4)
    
    FOR I = 2 TO 4

      IF RTRIM$(tank(I).tname) = "" THEN
        tmpname = ""
        SELECT CASE rndnum(I)
          CASE 1: tmpname = "Jess"
          CASE 2: tmpname = "Pete"
          CASE 3: tmpname = "Julie"
          CASE 4: tmpname = "Graeme"
          CASE 5: tmpname = "Laurel"
          CASE 6: tmpname = "Cary"
          CASE 7: tmpname = "Tim"
          CASE 8: tmpname = "Aaron"
          CASE 9: tmpname = "Michael"
          CASE 10: tmpname = "Daniel"
          CASE 11: tmpname = "Pauli"
          CASE 12: tmpname = "Matthew"
          CASE 13: tmpname = "Meryl"
          CASE 14: tmpname = "Richard"
          CASE 15: tmpname = "Jenny"
          CASE 16: tmpname = "Mike"
          CASE 17: tmpname = "Firespite"
          CASE 18: tmpname = "Paludis"
          CASE 19: tmpname = "Bismark"
          CASE 20: tmpname = "Killer"
          CASE 21: tmpname = "Nuker"
          CASE 22: tmpname = "Death"
          CASE 23: tmpname = "Destruction"
          CASE 24: tmpname = "Jemo"
          CASE 25: tmpname = "Coman"
          CASE 26: tmpname = "Libby"
          CASE 27: tmpname = "Kate"
          CASE 28: tmpname = "Laura"
          CASE 29: tmpname = "Lucy"
          CASE 30: tmpname = "Clare"
          CASE 31: tmpname = "Rachael"
          CASE 32: tmpname = "Dave"
          CASE 33: tmpname = "Paul"
          CASE 34: tmpname = "Rhys"
          CASE 35: tmpname = "Jo"
          CASE 36: tmpname = "Homer"
          CASE 37: tmpname = "Bart"
          CASE 38: tmpname = "Lisa"
          CASE 39: tmpname = "Marge"
          CASE 40: tmpname = "Maggie"
          CASE 41: tmpname = "Rembrant"
          CASE 42: tmpname = "Quinn"
          CASE 43: tmpname = "The Proffesor"
          CASE 44: tmpname = "Wade"
        END SELECT
        tank(I).tname = tmpname
      END IF
    NEXT I
    
    
  FOR I = 1 TO 4
      tanktype = tank(I).ttype
      ai = tank(I).smartness
      
      IF LEN(RTRIM$(tanktype)) = 10 THEN tanktype = "human"
      IF LEN(RTRIM$(ai)) = 10 THEN ai = "average"
     
      CALL locatecol(8, 24, STR$(I) + "", 3) 'print the tank number
      tankname = RTRIM$(tank(I).tname) 'set the name

      SELECT CASE I
        CASE 1: tankcolour = 4
        CASE 2: tankcolour = 1
        CASE 3: tankcolour = 5
        CASE 4: tankcolour = 14
      END SELECT
     
      CALL tankdraw(125, 450, 140, tankcolour + 0) 'draw the tank in the corner
    
      IF first = 1 THEN
        LINE (440, 132)-(500, 132), 0
        IF rename = 1 THEN CALL locatecol(7, 17, "RENAME", 3) ELSE CALL locatecol(7, 17, "NEW GAME", 3)
        CALL locatecol(8, 20, "Tank", 3)
        CALL locatecol(12, 20, "Human [ ]  Computer [ ]  Off [ ]", 3) 'do menu item
      END IF
      CALL locatecol(10, 20, "Name:                                    ", 3)
      CALL locatecol(10, 26, tankname, 4)
     
      IF I <> 4 THEN
        IF first = 1 THEN CALL locatecol(14, 18, "  Next->", 3)
      ELSE
        totalplayerstmp = 0
        FOR K = 1 TO 3
          IF RTRIM$(tankold(K).ttype) <> "off" THEN totalplayerstmp = totalplayerstmp + 1
        NEXT K
       
        DIM tmpmsg AS STRING
        tmpmsg = ""

        IF totalplayerstmp > 0 THEN
          IF rename = 1 THEN
            tmpmsg = "  Rename All "
          ELSE
            tmpmsg = "  Start "
          END IF
          IF totalplayerstmp = 1 THEN tmpmsg = tmpmsg + "(you must have at least 2 players)"
        ELSE
          tmpmsg = "  Exit (you must have at least 2 players) "
        END IF
        CALL locatecol(14, 18, tmpmsg, 3)
      END IF
      IF first = 1 THEN
        CALL locatecol(16, 20, "Computer Intelligence if applicable:", 3)
        CALL locatecol(18, 20, "Stupid  [ ]", 3)
        CALL locatecol(19, 20, "Average [ ]", 3)
        CALL locatecol(20, 20, "Smart   [ ]", 3)
        CALL locatecol(21, 20, "Killer  [ ]", 3)
        CALL locatecol(23, 20, "Exit", 3)
        first = 0
      ELSE
        FOR K = 18 TO 21
          CALL locatecol(K, 29, " ", 4)
        NEXT K
        CALL locatecol(12, 27, " ", 0)
        CALL locatecol(12, 41, " ", 0)
        CALL locatecol(12, 50, " ", 0)
      END IF
      CALL locatecol(14, 18, ">", 4)
     
      SELECT CASE RTRIM$(tanktype)
        CASE "human"
          CALL locatecol(12, 27, "X", 4)
        CASE "computer"
          CALL locatecol(12, 41, "X", 4)
        CASE "off"
          CALL locatecol(12, 50, "X", 4)
      END SELECT
      SELECT CASE RTRIM$(ai)
        CASE "stupid": CALL locatecol(18, 29, "X", 4)
        CASE "average": CALL locatecol(19, 29, "X", 4)
        CASE "smart": CALL locatecol(20, 29, "X", 4)
        CASE "killer": CALL locatecol(21, 29, "X", 4)
      END SELECT
     
      menuplace = 3
      DO
        ky = getkey
        IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
        IF ky = "up" OR ky = "left" THEN menuplace = menuplace - 1
        IF ky = "down" OR ky = "right" THEN menuplace = menuplace + 1
        IF menuplace = 0 OR ky = "escape" THEN menuplace = 8
        IF menuplace = 9 THEN menuplace = 1
        FOR K = 10 TO 20 STEP 2
          CALL locatecol(K, 18, " ", 1)
        NEXT K
        CALL locatecol(19, 18, " ", 1)
        CALL locatecol(21, 18, " ", 1)
        CALL locatecol(23, 18, " ", 1)
        SELECT CASE menuplace
          CASE 1
            CALL locatecol(10, 18, ">", 4)
          CASE 2
            CALL locatecol(12, 18, ">", 4)
          CASE 3
            CALL locatecol(14, 18, ">", 4)
          CASE 4
            CALL locatecol(18, 18, ">", 4)
          CASE 5
            CALL locatecol(19, 18, ">", 4)
          CASE 6
            CALL locatecol(20, 18, ">", 4)
          CASE 7
            CALL locatecol(21, 18, ">", 4)
          CASE 8
            CALL locatecol(23, 18, ">", 4)
        END SELECT
        IF ky = "enter" THEN
          IF menuplace = 2 THEN
            CALL locatecol(12, 20, "Human [ ]  Computer [ ]  Off [ ]", 3) 'do menu item
            SELECT CASE RTRIM$(tanktype)
              CASE "human"
                tanktype = "computer"
                CALL locatecol(12, 41, "X", 4)
              CASE "computer"
                tanktype = "off"
                CALL locatecol(12, 50, "X", 4)
              CASE "off"
                tanktype = "human"
                CALL locatecol(12, 27, "X", 4)
            END SELECT
          END IF
          IF menuplace >= 4 AND menuplace <= 7 THEN
              FOR K = 18 TO 21
                CALL locatecol(K, 29, " ", 4)
              NEXT K
          END IF
          SELECT CASE menuplace
            CASE 4
              CALL locatecol(18, 29, "X", 4)
              ai = "stupid"
            CASE 5
              CALL locatecol(19, 29, "X", 4)
              ai = "average"
            CASE 6
              CALL locatecol(20, 29, "X", 4)
              ai = "smart"
            CASE 7
              CALL locatecol(21, 29, "X", 4)
              ai = "killer"
          END SELECT

          IF menuplace = 1 THEN
            CALL locatecol(10, 19, ">", 4)
            COLOR 4
            LOCATE 10, 26
            place = 26
            endq = 0
            tmpname = nameinput(place + 0, 10, tankname, 21)
            IF MID$(tmpname, LEN(tmpname), 1) = "\" THEN
              CALL locatecol(10, place + 0, "                      ", 0)
              CALL locatecol(10, place + 0, tankname, 4)
              CALL locatecol(10, 19, " ", 0)
            ELSE
              tankname = tmpname
            END IF
            CALL locatecol(10, 19, " ", 4)
          END IF
        END IF
      LOOP UNTIL ky = "enter" AND menuplace = 3 OR ky = "enter" AND menuplace = 8
      IF menuplace = 8 THEN
        IF rename = 1 THEN menuplace = 2 ELSE menuplace = 1
        GOTO menustart
      END IF

      tankold(I).tname = tankname
      IF RTRIM$(tanktype) = "off" THEN tankold(I).status = 0 ELSE tankold(I).status = 1
      tankold(I).ttype = tanktype
      tankold(I).smartness = ai
  
  NEXT I
    totalplayerstmp = 0
    FOR I = 1 TO 4
      IF RTRIM$(tankold(I).ttype) <> "off" THEN totalplayerstmp = totalplayerstmp + 1
    NEXT I
    IF totalplayerstmp < 2 THEN
      IF rename = 1 THEN menuplace = 2 ELSE menuplace = 1
      GOTO menustart
    END IF
    FOR I = 1 TO 4
      tank(I).tname = tankold(I).tname
      tank(I).status = tankold(I).status
      tank(I).ttype = tankold(I).ttype
      tank(I).smartness = tankold(I).smartness
      IF RTRIM$(tank(I).ttype) = "off" THEN
        tank(I).totalscore = -1
        tank(I).status = 0
        tank(I).score = 0
      ELSEIF tank(I).totalscore < 0 THEN
        tank(I).totalscore = 0
      END IF
      
    NEXT I

   IF rename = 0 THEN

     rounds = 0
     FOR I = 1 TO 4
       tank(I).score = 0
       tank(I).totalscore = 0
       tank(I).weapon = "Missile  "
     NEXT I
     query = 1
     ingame = "no"
   END IF
          
  IF tank(1).status + tank(2).status + tank(3).status + tank(4).status <= 1 THEN
    IF rename = 1 THEN menuplace = 2 ELSE menuplace = 1
    GOTO menustart
  END IF

  ky = INKEY$
  ky = ""
 
  totalplayers = 0

  FOR I = 1 TO 4
    IF RTRIM$(tank(I).ttype) <> "off" THEN totalplayers = totalplayers + 1
  NEXT I
  DO
      turn = INT(4 * RND) + 1
  LOOP UNTIL tank(turn).status = 1
 
  IF rename = 1 THEN
    rename = 0
    RETURN
  END IF
  GOTO inplay
  END IF
  menuplace = 1
  GOTO menu2
'********** End of Menu ***********

'************ In Game *************
inplay:

  FOR I = 1 TO 4
    tankold(I).totalscore = tank(I).totalscore
    tankold(I).angle = tank(I).angle
    tankold(I).power = tank(I).power
    tankold(I).weapon = tank(I).weapon
    tankold(I).score = tank(I).score
    tankold(I).scores = tank(I).scores
    tankold(I).totalscore = tank(I).totalscore
    oldrounds = rounds
  NEXT I
  FOR I = 1 TO 4
    tank(I).score = 0
    tank(I).scores = ""
    tank(I).power = 65
  NEXT I

  IF tank(turn).status = 0 THEN
    IF tank(1).status = 1 THEN
      turn = 1
    ELSEIF tank(2).status = 1 THEN turn = 2
    ELSEIF tank(3).status = 1 THEN turn = 3
    ELSEIF tank(4).status = 1 THEN turn = 4
    END IF
  END IF

  ingame = "yes"

  '** get gravity
  SELECT CASE gravity
    CASE "Moon"
      neumericgravity = 4
    CASE "Earth"
      neumericgravity = 9.8
    CASE "Jupiter"
      neumericgravity = 20
  END SELECT
 
  '** Count the number of players
  players = 0
  FOR I = 1 TO 4
    IF RTRIM$(tank(I).ttype) <> "off" THEN players = players + 1
    IF RTRIM$(tank(I).ttype) = "off" THEN tank(I).status = 0 ELSE tank(I).status = 1
  NEXT I

  ky = "n" 'the map will redraw everytime n (no) is pressed.  Initially it is n (to draw it the first time)
  DO
    IF ky = "n" THEN
      SELECT CASE terrainheight
        CASE "rocky"
          numb = 0
        CASE "hilly"
          numb = 1
        CASE "mountainous"
          numb = 2
        CASE "alpine"
          numb = 3
      END SELECT
      exited = 0
     
      '** get the terrain colour
      IF terraincolor = "random" THEN
        terraincolour = INT(2 * RND + 1)
        IF terraincolour = 1 THEN terraincolour = 6
      ELSEIF terraincolor = "green" THEN terraincolour = 2
      ELSE terraincolour = 6
      END IF

      number = 300 * RND + 100 'starting height
      terrainver = 0
      terrainhor = 0
      GOSUB drawterrain
      LINE (0, 0)-(640, 15), 0, BF 'clear the top "menu" screen
    END IF

question:
    CALL locatecol(1, 1, "Do you want to use this terrain? y/n", 4)
    FOR I = 1 TO 60
      ky = INKEY$
    NEXT
    SLEEP 1
    ky = getkey
    IF ky = "escape" THEN
      GOSUB pauseexit
      LINE (0, 0)-(640, 15), 0, BF
      GOTO question
    END IF
  LOOP WHILE ky <> "y"
 
  watch = 2
  TIMER ON

  '** get rarity of the plane bombings
  IF planes = "rare" THEN
    ON TIMER(42) GOSUB planedrop
  ELSEIF planes = "sometimes" THEN
    ON TIMER(5) GOSUB planedrop '16
  ELSE
    TIMER OFF
  END IF
  flight = 1
 
  '**** Beginning of the actual gameplay code.  This will loop untill only 1 tank remains, exit is pressed or there are no humans (unless the humans want to watch)
  DO WHILE tank(1).status + tank(2).status + tank(3).status + tank(4).status > 1
   
    '** prints out whose turn it is
    COLOR 1
    LINE (1, 1)-(640, 15), 0, BF
    LOCATE 1, 1: PRINT "Tank"
    LOCATE 1, 5: PRINT turn
    tankname = RTRIM$(tank(turn).tname)
    IF LEN(tankname) > 0 THEN CALL locatecol(1, 7, ",", 1)
    CALL locatecol(1, 9, tankname, 4)
    SLEEP 1
   
    FOR I = 1 TO 90 'clear the keyboard strokes
      ky = INKEY$
    NEXT
    ky = ""
     
    '** determine if it is a computers turn or a humans turn and whether or not humans want to watch (if there are no humans left)
    IF watch = 2 THEN
      humans = 0
      FOR I = 1 TO 4
        IF RTRIM$(tank(I).ttype) = "human" AND tank(I).status <> 0 THEN humans = 1
      NEXT I
      COLOR 4
      IF humans = 0 THEN
        flight = 0
        LINE (0, 0)-(640, 15), 0, BF
        CALL locatecol(1, 1, "There are no human players left.  Do you want to keep watching? y/n", 4)
        DO
          ky = getkey
        LOOP UNTIL ky = "y" OR ky = "n"
        flight = 1
        IF ky = "n" THEN
          watch = 0
        ELSEIF ky = "y" THEN
           watch = 1
           LINE (0, 0)-(640, 15), 0, BF
           CALL locatecol(1, 1, "Computing...", 4)
        END IF
        FOR I = 1 TO 90
          ky = INKEY$
        NEXT
      END IF
       ky = ""
    END IF
    
    IF watch = 0 THEN
      flight = 0
      numstupid = 0
      numaverage = 0
      numsmart = 0
      numkiller = 0

        FOR I = 1 TO 4
          IF tank(I).status <> 0 THEN
            SELECT CASE RTRIM$(tank(I).smartness)
              CASE "stupid"
                numstupid = numstupid + 1
              CASE "average"
                numaverage = numaverage + 1
              CASE "smart"
                numsmart = numsmart + 1
              CASE "killer"
                numkiller = numkiller + 1
            END SELECT
          END IF
        NEXT I
        rannum(1) = INT(players * RND + 1)
      
        FOR I = 2 TO players
          rannum(I) = 0
          DO
            num = INT(players * RND + 1)
          LOOP WHILE num = rannum(1) OR num = rannum(2) OR num = rannum(3) OR num = tanknum(4)
          rannum(I) = num
        NEXT I
        
        computerplayers = 0
        FOR I = 1 TO 4
          IF RTRIM$(tank(I).ttype) = "computer" AND tank(I).status <> 0 THEN
            computerplayers = computerplayers + 1
            tank(I).score = rannum(computerplayers)
          END IF
          
        NEXT I
       
        num = INT(3 * RND + 1)
      
        IF numkiller + numsmart = 1 THEN
          ' stupid, average never win
          FOR I = 1 TO 4
            IF tank(I).status <> 0 AND tank(I).score <> 1 THEN
              IF RTRIM$(tank(I).smartness) = "killer" OR RTRIM$(tank(I).smartness) = "smart" THEN
                num = INT(5 * RND + 1)
                IF num > 2 THEN
                  FOR J = 1 TO 4
                    IF tank(J).score = 1 THEN
                      tank(J).score = tank(I).score
                      tank(I).score = 1
                  '3 in 5 if killer loses swap winners with his
                    EXIT FOR
                    END IF
                  NEXT J
                END IF
              END IF
            END IF
          NEXT I

        ELSEIF numstupid + numaverage = 1 THEN
          FOR I = 1 TO 4
            IF tank(I).status <> 0 AND tank(I).score = 1 THEN
              IF RTRIM$(tank(I).smartness) = "average" OR RTRIM$(tank(I).smartness) = "stupid" AND tank(I).score = 1 THEN
                num = INT(5 * RND + 1)
                IF num >= 2 THEN
                  FOR J = 1 TO 4
                    IF tank(J).score = 2 THEN
                      tank(J).score = 1
                      tank(I).score = 2
                  '3 in 5 if killer loses swap winners with his
                      EXIT FOR
                    END IF
                  NEXT J
                END IF
              END IF
            END IF
          NEXT I
         
         
          FOR I = 1 TO 4
            tank(I).status = 0
          NEXT
         
        END IF
        
        
          FOR I = 1 TO 4
            tank(I).status = 0
          NEXT

        EXIT DO
        flight = 1
    END IF
   
    LINE (0, 0)-(640, 15), 0, BF 'clear menu
    wind = windmake(maxwind) 'create the wind for this turn
   
    '** detect current tanks last position
    tankx = tank(turn).xpos
    tanky = tank(turn).ypos
    angle = tank(turn).angle
    power = tank(turn).power
    tanktype = RTRIM$(tank(turn).ttype)
    weapon = tank(turn).weapon
    tankcol = tank(turn).col
   
    '** it the tank is a human, then let him change power angle weapon etc
    IF RTRIM$(tanktype) = "human" THEN

      CALL locatecol(1, 1, "Angle:     Power:     Weapon:           Wind:                   Press H for help", 1)
      COLOR 4
      LOCATE 1, 7: PRINT angle
      LOCATE 1, 17: PRINT power
      CALL locatecol(1, 31, weapon, 4)
      CALL locatecol(1, 71, "H", 15)
    CALL winddraw(wind * 5) 'draw an arrow representing the wind
    DO

      ky = getkey

      '** switch weapon
      IF ky = "w" THEN
        IF weapon = "Missile  " THEN
          weapon = "Terraform"
        ELSE
          weapon = "Missile  "
        END IF
      END IF

      '** show escape menu option
      IF ky = "p" OR ky = "escape" THEN
        GOSUB pauseexit
      END IF

      '** display ingame help information
      IF ky = "h" OR ky = "/" OR ky = "?" OR ky = "t" THEN
        flight = 0
        LINE (1, 1)-(640, 15), 0, BF
        IF ky = "h" THEN
          CALL locatecol(1, 1, "up and down keys change power, left and right change angle and W changes weapon.", 1)
          ky = getkey
          LINE (1, 1)-(640, 15), 0, BF
        END IF
       
        '** display whose turn it is
        COLOR 1
        LOCATE 1, 1: PRINT "Tank"
        LOCATE 1, 5: PRINT turn
        tankname = RTRIM$(tank(turn).tname)
       
        IF LEN(tankname) > 0 THEN CALL locatecol(1, 7, ",", 1)
        CALL locatecol(1, 9, tankname, 4)
        ky = getkey
        ky = ""
        CALL locatecol(1, 1, "Angle:     Power:     Weapon:           Wind:                   Press H for help", 1)
        COLOR 4
        LOCATE 1, 7: PRINT angle
        LOCATE 1, 17: PRINT power
        CALL locatecol(1, 31, weapon, 4)
        CALL locatecol(1, 71, "H", 15)
        CALL winddraw(wind * 5)
        flight = 1
      END IF
     
      aold = angle
      IF ky = "right" THEN angle = angle - 1
      IF ky = "left" THEN angle = angle + 1
      IF ky = "up" AND power < 150 THEN power = power + 1
      IF ky = "down" AND power > 2 THEN power = power - 1
      IF ky = "a" AND power <= 140 THEN power = power + 10
      IF ky = "z" AND power > 10 THEN power = power - 10
      IF ky = "d" THEN angle = angle + 10
      IF ky = "f" THEN angle = angle - 10
     
      IF angle < 0 THEN angle = 180
      IF angle > 180 THEN angle = 0
                               
      IF aold > 90 AND angle <= 90 THEN LINE (tankx - 1, tanky)-(tankx + 35, tanky - 30), 9, BF 'erase tank
      IF aold <= 90 AND angle > 90 THEN LINE (tankx - 1, tanky)-(tankx + 35, tanky - 30), 9, BF
     
      IF ky = "right" OR ky = "left" OR ky = "d" OR ky = "f" THEN CALL armmove(angle + 0, tankx + 0, tanky - 0, tankcol + 0) 'if the angle was changed, move the arm
     
      '** redraw angle and power etc
      CALL locatecol(1, 10, " ", 1)
      COLOR 4
      LOCATE 1, 7: PRINT angle
      LOCATE 1, 17: PRINT power
      CALL locatecol(1, 31, weapon, 4)
      CALL locatecol(1, 71, "H", 15)

    LOOP UNTIL ky = "enter" OR ky = "space"
 
    '** Computer Tanks
    ' How the ai works:
    '  Firstly, the computer goes through each angle and power,
    '  and "fires" a simulated shot. If it would have hit a tank (had it been real)
    '  Then it remembers that shot. The computers ai level, then adds an amount off
    '  error to the shot, ie if it is smart, it will more likly hit than if it is less smart

    ELSEIF RTRIM$(tanktype) = "computer" THEN
      smartness = RTRIM$(tank(turn).smartness)

redonotstatus:   'if there was an airoplane flight during the computers turn, then a tank (including itself) may have been hit, and the turn may have changed.

      'calculate which returned status would be unacceptable (as it "hit" itself)
      SELECT CASE turn
        CASE 1: notstatus = 222
        CASE 2: notstatus = 2022
        CASE 3: notstatus = 2202
        CASE 4: notstatus = 2220
      END SELECT
     
      IF recentflight = 1 THEN
        recentflight = 0
        RETURN
      END IF

      ON recentflight = 1 GOSUB redonotstatus
      CALL locatecol(1, 1, "Computing...", 4)
      CALL winddraw(wind * 5)
     
      status = 0
      recentflight = 0

      FOR power = 50 TO 150 STEP 20
        FOR angle = 10 TO 170 STEP 10
               
          '** if escape is pressed
          ky = INKEY$
          IF ky <> "p" AND ky <> "" THEN ky = "escape"
          IF ky = "p" OR ky = "escape" THEN
            GOSUB pauseexit
          END IF
          ky = ""

          IF recentflight = 1 THEN GOSUB redonotstatus
          status = shoot(tankx + 0, tanky + 0, angle + 0, power + 0, wind + 0, neumericgravity + 0, weapon, terraincolour + 0, tank(1).xpos + 0, tank(1).ypos + 0, tank(2).xpos + 0, tank(2).ypos + 0, tank(3).xpos + 0, tank(3).ypos + 0, tank(4).xpos + _
 0, tank(4).ypos + 0, tank(1).status + 0, tank(2).status + 0, tank(3).status + 0, tank(4).status + 0, 2, first + 0, last + 0)
          IF status <> 2222 AND status <> notstatus THEN EXIT FOR '2222 indicates no tank was hit, notstatus indicates the current tank hit itself.  Otherwise, another tank was targeted, therefore the loop is exited.
        NEXT angle
        IF status <> 2222 AND status <> notstatus THEN EXIT FOR
      NEXT power
     
      '** if no tank could be targated, then do a more extensive search (takes longer)
      IF status = 2222 OR status = notstatus THEN
        FOR power = 0 TO 150 STEP 10 'smaller steps than before incase tank was missed
          FOR angle = 0 TO 180 STEP 5
            '** if escape is pressed
            ky = INKEY$
            IF ky <> "p" AND ky <> "" THEN ky = "escape"
            IF ky = "p" OR ky = "escape" THEN
              GOSUB pauseexit
            END IF
            ky = ""

            IF recentflight = 1 THEN GOSUB redonotstatus
            status = shoot(tankx + 0, tanky + 0, angle + 0, power + 0, wind + 0, neumericgravity + 0, weapon, terraincolour + 0, tank(1).xpos + 0, tank(1).ypos + 0, tank(2).xpos + 0, tank(2).ypos + 0, tank(3).xpos + 0, tank(3).ypos + 0, tank(4).xpos _
 + 0, tank(4).ypos + 0, tank(1).status + 0, tank(2).status + 0, tank(3).status + 0, tank(4).status + 0, 2, first + 0, last + 0)
            IF status <> 2222 AND status <> notstatus THEN EXIT FOR'GOTO 2'EXIT FOR
          NEXT angle
          IF status <> 2222 AND status <> notstatus THEN EXIT FOR'GOTO 2'EXIT FOR
        NEXT power
        '** no tank can be targated, therefore a random angle and power are chosen
        IF status = 2222 OR status = notstatus THEN
          angle = angle + INT(20 * RND - 10)
          power = INT(60 * RND + 30)
        END IF
      END IF
     
      CALL locatecol(1, 1, "            ", 0)
     
      '** set the level of error (depending on the smartness of the tank)
      SELECT CASE smartness
        CASE "stupid": cai = 16
        CASE "average": cai = 8
        CASE "smart": cai = 4
        CASE "killer": cai = 2
      END SELECT

      '** determine if error should increase the range or decrease
      sign = INT(2 * RND + 1)
      IF sign = 2 THEN sign = -1

      addamount = INT((cai * 2 + 1) * RND)
      IF cai = 16 THEN addamount = addamount + 3 * sign 'the +3 indicates there is always a level or errror present
      IF cai = 8 THEN addamount = addamount + 1 * sign
      power = power + addamount * sign
      angle = angle + addamount * -sign
      LINE (tankx - 1, tanky)-(tankx + 35, tanky - 30), 9, BF 'erase tank
      CALL armmove(angle + 0, tankx + 0, tanky - 0, tankcol + 0) 'change arm on tank
    END IF
    
    '** the following code is executed for both tanks and humans

    flight = 0
   
    '** determine if the computer will use a missile or the terraform weapon
    num = INT(5 * RND + 1)
    IF RTRIM$(tanktype) = "computer" THEN
      IF num = 1 THEN weapon = "Terraform" ELSE weapon = "Missile  "
    END IF

    '** Fire weapon using selected values
    status = shoot(tankx + 0, tanky + 0, angle + 0, power + 0, wind + 0, neumericgravity + 0, weapon, terraincolour + 0, tank(1).xpos + 0, tank(1).ypos + 0, tank(2).xpos + 0, tank(2).ypos + 0, tank(3).xpos + 0, tank(3).ypos + 0, tank(4).xpos + 0,  _
tank(4).ypos + 0, tank(1).status + 0, tank(2).status + 0, tank(3).status + 0, tank(4).status + 0, 0, first + 0, last + 0)
    
shoot:
   
    '** break down returned status into individual tanks
    stat(1) = status \ 1000
    status = status - stat(1) * 1000
    stat(2) = status \ 100
    status = status - stat(2) * 100
    stat(3) = status \ 10
    status = status - stat(3) * 10
    stat(4) = status

    '** change the current status of tanks depending on the result
    FOR I = 1 TO 4
      IF stat(I) = 0 THEN
        tank(I).score = players
        players = players - 1
        tank(I).status = 0
      END IF
    NEXT I
    
nextperson:
    IF tank(1).status + tank(2).status + tank(3).status + tank(4).status <= 1 THEN GOTO skip
    
    tank(turn).angle = angle
    tank(turn).power = power
    tank(turn).weapon = weapon
    'finds next tank's turn

    currentturn = turn

    FOR I = turn + 1 TO 4
      IF tank(I).status = 1 THEN
        turn = I
        EXIT FOR
      END IF
    NEXT I
    
    FOR I = 1 TO 4
      IF tank(I).status <> 0 THEN
        a = tank(I).angle
        IF a > 90 AND a <= 180 THEN a = a + 180
        CALL armmove(a + 0, tank(I).xpos, tank(I).ypos, tank(I).col)
      END IF
    NEXT I
   
    IF currentturn = turn THEN
      FOR I = 1 TO turn - 1
        IF tank(I).status = 1 THEN
          turn = I
        
          EXIT FOR
        END IF
      NEXT I
    END IF
   
    flight = 1
    turnold = turn 'this keeps track of the turn incase rename is chosen

skip:

  LOOP
  '** End of that round
 
  '** allocate rankings

  rounds = rounds + 1
  players = 0
           
  FOR I = 1 TO 4
    IF tank(I).status <> 0 THEN tank(I).score = 1
  NEXT I
  FOR I = 1 TO 4
    IF RTRIM$(tank(I).ttype) <> "off" THEN tank(I).totalscore = tank(I).totalscore + (totalplayers + 1 - tank(I).score)
  NEXT I
GOTO menustart
END

planedrop: '** executed when the plane drops a bomb (as given by the timer)
  IF flight = 1 THEN
    flight = 0
    bomb = 0
    xstop = INT(640 * RND + 1)
    planeweapon = "Missile  "
    FOR x = 640 TO -100 STEP -.5
      IF xstop = x AND bomb = 0 THEN
        status = shoot(xstop + 10, 44, 270, 0, wind + 0, neumericgravity + 0, planeweapon, terraincolour + 0, tank(1).xpos + 0, tank(1).ypos + 0, tank(2).xpos + 0, tank(2).ypos + 0, tank(3).xpos + 0, tank(3).ypos + 0, tank(4).xpos + 0, tank(4).ypos  _
+ 0, tank(1).status + 0, tank(2).status + 0, tank(3).status + 0, tank(4).status + 0, 1, first + 0, last + 0)
        bomb = 1
      END IF
      CALL planedraw(x + 3, 50, 9)
      CALL planedraw(x + 0, 50, 4)
    NEXT
   
   
    stat(1) = status \ 1000
    status = status - stat(1) * 1000
    stat(2) = status \ 100
    status = status - stat(2) * 100
    stat(3) = status \ 10
    status = status - stat(3) * 10
    stat(4) = status

    FOR I = 1 TO 4
      IF stat(I) = 0 THEN
        
        tank(I).score = players
        players = players - 1
        tank(I).status = 0
        IF players = 1 AND tank(turn).status = 1 THEN
          tank(I).totalscore = tank(I).totalscore + totalplayers - 1
          tank(turn).totalscore = tank(turn).totalscore + totalplayers
          rounds = rounds + 1
       
        ELSEIF players = 1 THEN
          tank(I).totalscore = tank(I).totalscore + totalplayers - 1
          FOR K = 1 TO 4
            IF tank(K).status = 1 THEN
              tank(K).score = 1
              tank(K).totalscore = tank(K).totalscore + totalplayers
            END IF
          NEXT K
          
          rounds = rounds + 1

        END IF
      END IF
    NEXT I

    
    IF tank(1).status + tank(2).status + tank(3).status + tank(4).status <= 1 THEN
      ingame = "yes"
      GOTO menustart
    ELSE
      IF tank(turn).status = 0 THEN GOTO nextperson
    END IF
   
    FOR I = 1 TO 90
      ky = INKEY$
      ky = ""
    NEXT I
    flight = 1
  END IF
      
RETURN

'---------------- terrain ---------------
drawterrain:
  terrainver = 0
  terrainhor = 0
 
  numb = numb * 2 'double the number of hill gradients (to account for assending and descending)

  LINE (0, 0)-(640, 500), 9, BF  'draws sky
  '** How the terain works
  ' If the terrain was simply random, a jagged but flat line would be drawn.
  ' The method used here is that a hill type is selected (from 0 to 7) with 0 being flat and 7 being steep
  ' and it is either downhill or uphill.  Within the current type, a very small element of randomness to make it rough

  FOR cnt = 0 TO 640
    IF terrainhor <= cnt THEN

redo:
      terrainver = INT(numb * RND) 'select new hill type (the higher positive or negative you go, the more extreem the gradient)
      IF numb = 6 AND terrainver = 3 OR terrainver = 4 THEN GOTO redo 'numb was to steep a change
      terrainhor = INT(20 * RND + 10 + cnt) 'determine the width of the hill
    END IF
   
    SELECT CASE terrainver 'depending on the type, generate the new additional height
      CASE 0
        num = INT(3 * RND)
        sign = INT(2 * RND + 1)
        IF sign = 2 THEN num = -num
      CASE 1: num = -INT(3 * RND + 0)
      CASE 2: num = INT(3 * RND + 0)
      CASE 3: num = -INT(5 * RND + .5)
      CASE 4: num = INT(5 * RND + .5)
      CASE 5: num = -INT(7 * RND + 1)
      CASE 6: num = INT(7 * RND + 1)
    END SELECT
    number = number + num 'number is the current height, add (or subtract) the addition of the hill

    '** Leave flat land for tanks
    IF RTRIM$(tank(1).ttype) <> "off" THEN
      IF cnt > 42 AND cnt < 91 THEN
        number = number - num
        tank(1).ypos = number - 1
        tank(1).angle = 45
        tank(1).xpos = 50
      END IF
    ELSE
      tank(1).status = 0
    END IF
   
    IF RTRIM$(tank(2).ttype) <> "off" THEN
      IF cnt > 199 AND cnt < 256 THEN
        number = number - num
        tank(2).ypos = number - 1
        tank(2).angle = 125
        IF RTRIM$(tank(1).ttype) = "off" THEN tank(2).angle = 45
        tank(2).xpos = 208
      END IF
    ELSE
      tank(2).status = 0
    END IF
   
    IF RTRIM$(tank(3).ttype) <> "off" THEN
      IF cnt > 367 AND cnt < 418 THEN
        number = number - num
        tank(3).ypos = number - 1
        tank(3).angle = 45
        IF RTRIM$(tank(4).ttype) = "off" THEN tank(3).angle = 125
        tank(3).xpos = 376
      END IF
    ELSE
      tank(3).status = 0
    END IF
    IF RTRIM$(tank(4).ttype) <> "off" THEN
      IF cnt > 526 AND cnt < 579 THEN
        number = number - num
        tank(4).ypos = number - 1
        tank(4).angle = 125
        tank(4).xpos = 535
      END IF
    ELSE
      tank(4).status = 0
    END IF
     IF number < 100 THEN terrainver = 6
     IF number > 540 THEN terrainver = 5
     IF number > 478 THEN number = 478
     IF number < 50 THEN number = 50
    LINE (cnt, number)-(cnt, 600), terraincolour
    IF cnt = 1 THEN first = number
    IF cnt = 640 THEN last = number
  NEXT cnt
   
  '** draw tanks
  IF RTRIM$(tank(1).ttype) <> "off" THEN CALL armmove(45, 50, tank(1).ypos + 0, 4)
  IF RTRIM$(tank(2).ttype) <> "off" THEN CALL armmove(tank(2).angle + 0, 208, tank(2).ypos + 0, 1)
  IF RTRIM$(tank(3).ttype) <> "off" THEN CALL armmove(tank(3).angle + 0, 376, tank(3).ypos + 0, 5)
  IF RTRIM$(tank(4).ttype) <> "off" THEN CALL armmove(125, 535, tank(4).ypos + 0, 14)

RETURN

SS: 'run the screensaver in the menu, if there is no movement
  
  DO
    CALL tankdraw(INT(180 * RND), INT(649 * RND - 19), INT(480 * RND + 1), INT(14 * RND + 1))
    ky = INKEY$
  LOOP WHILE ky = ""
 

  GOTO menustart
      
pauseexit: 'when escape is pressed
        flight = 0
        LINE (1, 1)-(640, 15), 0, BF
        IF ky = "escape" THEN CALL locatecol(1, 1, "Exit to menu? y/n", 4) ELSE CALL locatecol(1, 1, "Paused press any key to continue", 4)
        SLEEP 1
        keypress = getkey
        IF ky = "p" THEN
          ky = ""
        ELSE
          IF keypress = "y" THEN
            exited = 1
            IF rounds < 1 THEN menuplace = 1 ELSE menuplace = 3
            GOTO menustart
          END IF
        END IF
        LINE (1, 1)-(640, 15), 0, BF
       
        IF tanktype = "human" THEN
          CALL locatecol(1, 1, "Angle:     Power:     Weapon:           Wind:                   Press H for help", 1)
          COLOR 4
          LOCATE 1, 7: PRINT angle
          LOCATE 1, 17: PRINT power
          CALL locatecol(1, 31, weapon, 4)
          CALL locatecol(1, 71, "H", 15)
          ky = ""
        ELSE
          CALL locatecol(1, 1, "Computing...", 4)
        END IF
        CALL winddraw(wind * 5)
       
        flight = 1
  
RETURN

SUB armmove (angle AS INTEGER, x AS INTEGER, y AS INTEGER, colour AS INTEGER)
 

  IF angle > 90 AND angle <= 180 THEN angle = angle + 180
  a = angle * 3.141592654# / 180
  verdis = (15 * COS(a))
  hordis = (15 * SIN(a))
  FOR I = x + 26 TO x + 35           '27
    LINE (I, y - 14)-(I + 3, y - 9), 9   '13
  NEXT
  LINE (I, y - 13)-(I + 3, y - 9), 9, BF
  FOR I = x - 10 TO x + 3
    LINE (I, y - 9)-(I + 4, y - 13), 9
  NEXT I

    
  LINE (x - 10, y - 25)-(x + 42, y - 14), 9, BF
'  LINE (x - 8, y - 9)-(x + 9, y - 30), 2, BF
'  LINE (x + 26, y - 9)-(x + 42, y - 30), 2, BF
  IF angle > 90 THEN GOTO tankl

tankr:

  FOR I = x + 2 TO x + 28
    LINE (I, y - 1)-(I + 4, y - 7), colour
  NEXT I

  FOR I = x + 10 TO x + 14
    LINE (I, y - 9)-(I + 4, y - 13), colour
  NEXT I

  FOR I = x + 24 TO x + 25
    LINE (I, y - 13)-(I + 3, y - 9), colour
  NEXT I
  LINE (x + 10, y - 8)-(14 + x, y - 13), colour
  LINE (14 + x, y - 13)-(24 + x, y - 13), colour
  LINE (24 + x, y - 13)-(27 + x, y - 8), colour
 
  LINE (x, y)-(27 + x, y), 0
  LINE (27 + x, y)-(33 + x, y - 8), 0
  LINE (x + 6, y - 8)-(33 + x, y - 8), 0
  LINE (x, y)-(x + 6, y - 8), 0
  LINE (26 + x, y - 9)-(x + 14, y - 13), colour, BF
  LINE (x + 24, y - 10)-(x + 24 + verdis, y - 10 - hordis), colour
EXIT SUB

tankl:
  FOR I = x + 1 TO x + 27
    LINE (I + 5, y - 1)-(I, y - 7), colour
  NEXT I
  LINE (x + 5, y - 1)-(x, y - 7), 0
 
  FOR I = x + 5 TO x + 8
    LINE (I, y - 9)-(I + 4, y - 13), colour
  NEXT I

  FOR I = x + 18 TO x + 19
    LINE (I, y - 13)-(I + 3, y - 9), colour
  NEXT I
 
  LINE (x + 4, y - 8)-(8 + x, y - 13), colour
  LINE (8 + x, y - 13)-(18 + x, y - 13), colour
  LINE (18 + x, y - 13)-(21 + x, y - 8), colour
 
  LINE (x + 6, y)-(33 + x, y), 0
  LINE (x - 1, y - 8)-(6 + x, y), 0
  LINE (x - 1, y - 8)-(27 + x, y - 8), 0
  LINE (x + 27, y - 8)-(33 + x, y), 0
                                             

  LINE (9 + x, y - 13)-(20 + x, y - 9), colour, BF
  LINE (x + 9, y - 10)-(x + 9 - verdis, y - 10 + hordis), colour


END SUB

SUB box (xi AS INTEGER, yi AS INTEGER, xf AS INTEGER, yf AS INTEGER, boxwidth AS INTEGER, boardercolour AS INTEGER, fillcolour AS INTEGER)
  LINE (xi + boxwidth, yi + boxwidth)-(xf - boxwidth, yf - boxwidth), fillcolour, BF
  LINE (xi, yi)-(xf, yi + boxwidth), boardercolour, BF
  LINE (xf, yi)-(xf - boxwidth, yf), boardercolour, BF
  LINE (xf, yf)-(xi, yf - boxwidth), boardercolour, BF
  LINE (xi, yf)-(xi + boxwidth, yi), boardercolour, BF

END SUB

SUB capsoff STATIC
' Turn Caps Lock off
   DEF SEG = 0
   ' Set Caps Lock off (turn off bit 6 of &H0417)
   POKE &H417, PEEK(&H417) AND &HBF
   DEF SEG

END SUB

SUB circlefill (x AS INTEGER, y AS INTEGER, radias AS INTEGER, colour AS INTEGER) STATIC
  DIM radi AS INTEGER
  DIM radii AS INTEGER

  FOR radi = 1 TO radias
    IF radias < 10 THEN radias = 10
    CIRCLE (x, y), radi, colour
    CIRCLE (x + 1, y + 1), radi, colour
    CIRCLE (x + 1, y - 1), radi, colour
  NEXT radi
  radii = radi
  FOR radii = radi - 2 TO radi
    CIRCLE (x - 1, y + 1), radii, colour
    CIRCLE (x, y + 1), radii, colour
    CIRCLE (x + 1, y), radii, colour
  NEXT radii
  LINE (x, y)-(x, y), colour
  
END SUB

FUNCTION getkey$
'  CONST enter = 13, ESCAPE = 27, SPACE = 32
'  CONST DOWNARROW = 80, UPARROW = 72, LEFTARROW = 75, RIGHTARROW = 77
'  CONST excl = 33, andsign = 36, asterisk = 42, hyphen = 45, comma = 44
'const hash = 35, percent= 37, dollar = 36, attherateof = 64, hat = 94  ,apostraphy = 39, brac1 = 40, brac2 = 41, colon = 58
'const fullstop =46 , lessthan = 60, greaterthan = 62, square1 = 91, square2 = 93, curv1 =123 ,curv2 = 125, plus = 43, underline = 95, equal = 61
'const backslash = 92, forardslash = 47, verticleline = 124, semicolon = 59, quotations =34 , question = 63
     'asc
 '먮
 
  DIM keypress AS STRING
  DIM asckeypress AS INTEGER

  DO
    capsoff
    keypress = INKEY$
  LOOP WHILE keypress = ""
  asckeypress = ASC(RIGHT$(keypress, 1))

  SELECT CASE asckeypress
    CASE Space
      getkey = "space"
    CASE Escape
      getkey = "escape"
    CASE Uparrow
      getkey = "up"
    CASE Downarrow
      getkey = "down"
    CASE enter
      getkey = "enter"
    CASE Rightarrow
      getkey = "right"
    CASE Leftarrow
      getkey = "left"
    CASE ELSE
      getkey = keypress
  END SELECT

END FUNCTION

SUB locatecol (row AS INTEGER, column AS INTEGER, sentence AS STRING, colors AS INTEGER) STATIC
  COLOR colors
  LOCATE row, column
  PRINT sentence
END SUB

FUNCTION nameinput$ (initplace AS INTEGER, row AS INTEGER, initname AS STRING, max AS INTEGER)
  DIM tankname AS STRING
  DIM ky AS STRING
  DIM askey AS INTEGER
  
            tankname = initname
            place = initplace + LEN(tankname) - 1
            DO                               'asc
              CALL locatecol(row + 0, place + 1, "", 4)
              DO
                ky = INKEY$
              LOOP WHILE ky = ""
              ky = symbols$(ky)
              SELECT CASE ky
                CASE "A" TO "Z", "a" TO "z", "0" TO "9", "-", "!", "&", "*", "@", "#", "$", "|", "^", "(", ")", ",", "'", ":", ";", "<", ">", ".", "%", "?", ".", "[", "=", "+", "]", "{", "}", "\", "/", "_", "", "", "", "", "", "", "", "",  _
"", "", "", "", "", "", ""' ,asc
                  IF LEN(tankname) < max THEN
                    place = place + 1
                    CALL locatecol(row, place + 0, ky, 4)
                    tankname = tankname + ky
                  END IF
                CASE ELSE
                  ascky = ASC(RIGHT$(ky, 1))
                  IF ascky = enter THEN endq = 1
                  IF ascky = Escape THEN
                   
                    nameinput = initname + "\"
                    EXIT FUNCTION

                  END IF

                  IF ascky = Space AND LEN(tankname) <= max - 1 THEN
                    place = place + 1
                    CALL locatecol(row, place + 0, ky, 4)
                    tankname = tankname + ky
                  END IF
                  IF ascky = Backspace AND initplace - 1 <> place THEN
                    tankname = MID$(tankname, 1, LEN(tankname) - 1)
                    place = place - 1
                    CALL locatecol(row, place + 1, "  ", 4)
                   
                  END IF

              END SELECT
              IF LTRIM$(tankname) = "" THEN endq = 0
            LOOP UNTIL endq = 1 OR LEN(tankname) > max
            CALL locatecol(row, place + 1, " ", 4)
            nameinput = tankname

END FUNCTION

SUB planedraw (x AS INTEGER, y AS INTEGER, colour AS INTEGER)

'wing 1
LINE (x + 25, y - 3)-(x + 41, y + 15), colour
LINE (x + 41, y + 15)-(x + 57, y + 15), colour
LINE (x + 57, y + 15)-(x + 40, y - 3), colour

'wing 2
LINE (x + 26, y - 15)-(x + 39, y - 28), colour
LINE (x + 39, y - 28)-(x + 55, y - 28), colour
LINE (x + 55, y - 28)-(x + 42, y - 15), colour

'tail wing
LINE (x + 52, y - 10)-(x + 65, y - 10), colour
LINE (x + 65, y - 10)-(x + 65, y - 13), colour
LINE (x + 52, y - 13)-(x + 65, y - 13), colour

'tail
LINE (x + 60, y - 13)-(x + 57, y - 25), colour
LINE (x + 57, y - 25)-(x + 48, y - 15), colour

'body
LINE (x + 44, y)-(x + 64, y), colour
LINE (x + 64, y)-(x + 61, y - 10), colour
LINE (x + 48, y - 15)-(x + 5, y - 15), colour
LINE (x + 5, y - 15)-(x - 10, y), colour
LINE (x - 10, y)-(x + 28, y), colour

'window
LINE (x + 6, y - 12)-(x + 2, y - 8), colour
LINE (x + 12, y - 12)-(x + 8, y - 8), colour
LINE (x + 6, y - 12)-(x + 12, y - 12), colour
LINE (x + 2, y - 8)-(x + 8, y - 8), colour

END SUB

FUNCTION shoot (xstart AS INTEGER, ystart AS INTEGER, angle AS INTEGER, power AS INTEGER, wind AS INTEGER, gravity AS INTEGER, weapon AS STRING, terraincolour AS INTEGER, tank1xpos AS INTEGER, tank1ypos AS INTEGER, tank2xpos AS INTEGER, tank2ypos AS _
 INTEGER, tank3xpos AS INTEGER, tank3ypos AS INTEGER, tank4xpos AS INTEGER, tank4ypos AS INTEGER, tank1status AS INTEGER, tank2status AS INTEGER, tank3status AS INTEGER, tank4status AS INTEGER, types AS INTEGER, first AS INTEGER, last AS INTEGER)
  'function, tankstatus

  IF angle > 90 AND angle <= 180 THEN
  ang = angle + 180
  ELSE
  ang = angle - 180
  END IF
  ang = ang * 3.141592654# / 180
  verdis2 = (17 * COS(ang))
  hordis2 = (17 * SIN(ang))
 
  IF angle <= 90 AND angle >= 0 THEN
    xstart = (xstart + 24) - verdis2
    ystart = (ystart - 10) + hordis2
  ELSE
    xstart = xstart + 9 - verdis2
    ystart = ystart - 10 + hordis2
  END IF

  colour = INT(8 * RND + 1)

  SELECT CASE colour
    CASE 1
      colour = 3
    CASE 2
      colour = 7
    CASE 3
      colour = 8
    CASE 4
      colour = 10
    CASE 5
      colour = 11
    CASE 6
      colour = 12
    CASE 7
      colour = 13
    CASE 8
      colour = 15
  END SELECT

  a = angle * 3.141592654# / 180
  hordis = (power * COS(a))
  verdis = (power * SIN(a))
  x = xstart
  y = ystart
  xold = x
  yold = y
  DO
 
  
    IF types <> 2 AND x < 640 AND x > 0 AND y < 640 AND y > 15 AND yold > 15 THEN LINE ((xold), (yold))-((x), (y)), colour
    xold = x
    yold = y
    x = x + hordis / 25
    y = y - verdis / 25
    verdis = verdis - gravity / 25
    hordis = hordis + wind / 50
  IF x < 640 AND x > 0 AND y < 640 AND y > 15 THEN
    pxlpoint = POINT(x, y)
    SELECT CASE pxlpoint
      CASE 1, 5, 4, 14, 2, 6
      explode = 1
    END SELECT
  END IF
  IF x < -500 OR x > 1150 OR y > 500 OR y < -1200 THEN explode = 2
  IF x < -250 AND y > first THEN explode = 2
  IF x > 900 AND y > last THEN explode = 2
  LOOP WHILE explode = 0
  xfinal = x
  yfinal = y
  IF types <> 2 THEN
    IF explode = 1 AND weapon = "Missile  " THEN
      CALL circlefill(x + 0, y + 0, 15, 4)
      CALL circlefill(x + 0, y + 0, 15, 9)
    END IF
    IF explode = 1 AND weapon = "Terraform" THEN
      CALL circlefill(x + 0, y + 0, 15, terraincolour + 0)
    END IF
  END IF


  hordis = (power * COS(a))
  verdis = (power * SIN(a))
  x = xstart
  y = ystart
  xold = x
  yold = y
  IF types = 0 THEN
    FOR I = 1 TO 90
      ky$ = INKEY$
    NEXT
    ky$ = ""
    SLEEP 1
  END IF
  IF types <> 2 THEN
    DO
      IF x < 640 AND x > 0 AND y < 640 AND y > 15 AND yold > 15 THEN LINE ((xold), (yold))-((x), (y)), 9
      xold = x
      yold = y
      x = x + hordis / 25
      y = y - verdis / 25
      verdis = verdis - gravity / 25
      hordis = hordis + wind / 50
      IF x = xfinal AND y = yfinal THEN ends = 1
    LOOP WHILE ends <> 1
  END IF
  tnkexplode = 0
  IF explode = 1 THEN
  IF weapon = "Terraform" AND types <> 2 THEN
    CALL circlefill(xfinal + 0, yfinal + 0, 15, terraincolour + 0)
  END IF
  xfinal = INT(xfinal)
  yfinal = INT(yfinal)
 
  FOR x = xfinal - 15 TO xfinal + 15
    FOR y = yfinal - 15 TO yfinal + 15
      IF tank1status = 1 THEN IF x > tank1xpos AND x < tank1xpos + 33 AND y < tank1ypos AND y > tank1ypos - 13 THEN tnkexplode = 1
      IF tank2status = 1 THEN IF x > tank2xpos AND x < tank2xpos + 33 AND y < tank2ypos AND y > tank2ypos - 13 THEN tnkexplode = 2
      IF tank3status = 1 THEN IF x > tank3xpos AND x < tank3xpos + 33 AND y < tank3ypos AND y > tank3ypos - 13 THEN tnkexplode = 3
      IF tank4status = 1 THEN IF x > tank4xpos AND x < tank4xpos + 33 AND y < tank4ypos AND y > tank4ypos - 13 THEN tnkexplode = 4
    NEXT y
  NEXT x
 
  
  tank1stats = 2
  tank2stats = 2
  tank3stats = 2
  tank4stats = 2
  SELECT CASE tnkexplode
    CASE 1
        tank1stats = 0
        IF types <> 2 THEN CALL circlefill(tank1xpos + 20, tank1ypos - 10, 25, 4)
        IF types <> 2 THEN CALL circlefill(tank1xpos + 20, tank1ypos - 10, 25, 9)
    CASE 2
        tank2stats = 0
        IF types <> 2 THEN CALL circlefill(tank2xpos + 20, tank2ypos - 10, 25, 4)
        IF types <> 2 THEN CALL circlefill(tank2xpos + 20, tank2ypos - 10, 25, 9)
    CASE 3
        tank3stats = 0
        IF types <> 2 THEN CALL circlefill(tank3xpos + 20, tank3ypos - 10, 25, 4)
        IF types <> 2 THEN CALL circlefill(tank3xpos + 20, tank3ypos - 10, 25, 9)
    CASE 4
        tank4stats = 0
        IF types <> 2 THEN CALL circlefill(tank4xpos + 20, tank4ypos - 10, 25, 4)
        IF types <> 2 THEN CALL circlefill(tank4xpos + 20, tank4ypos - 10, 25, 9)
   END SELECT
  ELSE
    tank1stats = 2
    tank2stats = 2
    tank3stats = 2
    tank4stats = 2
  
   END IF
   shoot = ((tank1stats * 10 + tank2stats) * 10 + tank3stats) * 10 + tank4stats


END FUNCTION

FUNCTION symbols$ (ky AS STRING)
'square1 = 91, square2 = 93, curv1 =123 ,curv2 = 125, plus = 43, underline = 95, equal = 61
'const backslash = 92, forardslash = 47, verticleline = 124, semicolon = 59, quotations =34 , question = 63
'
  SELECT CASE ASC(ky)
    CASE square1
      symbols = ""
    CASE square2
      symbols = ""
    CASE curv1
      symbols = ""
    CASE curv2
      symbols = ""
    CASE underline
      symbols = ""
    CASE equal
      symbols = ""
    CASE backslash
      symbols = ""
    CASE forardslash
      symbols = ""
', verticleline = 124, semicolon = 59, quotations =34 , question = 63
    CASE verticleline
      symbols = ""
    CASE semicolon
      symbols = ""
    CASE quotations
      symbols = ""
    CASE colon
      symbols = ""
    CASE percent
      symbols = ""
    CASE plus
      symbols = ""
    CASE ELSE
      symbols = ky
  END SELECT
END FUNCTION

SUB tankdraw (angle AS INTEGER, x AS INTEGER, y AS INTEGER, colour AS INTEGER)
  IF angle > 90 AND angle <= 180 THEN angle = angle + 180
  a = angle * 3.141592654# / 180
  verdis = (15 * COS(a))
  hordis = (15 * SIN(a))
  IF angle > 90 THEN GOTO tankl2

tankr2:

  FOR I = x + 2 TO x + 27
    LINE (I, y - 1)-(I + 4, y - 7), colour
  NEXT I

  FOR I = x + 10 TO x + 14
    LINE (I, y - 9)-(I + 5, y - 13), colour
  NEXT I

  FOR I = x + 24 TO x + 25
    LINE (I, y - 13)-(I + 2, y - 9), colour
  NEXT I
  LINE (x + 10, y - 8)-(14 + x, y - 13), colour
  LINE (14 + x, y - 13)-(24 + x, y - 13), colour
  LINE (24 + x, y - 13)-(27 + x, y - 8), colour

  LINE (x, y)-(27 + x, y), colour
  LINE (27 + x, y)-(33 + x, y - 8), colour
  LINE (x + 6, y - 8)-(33 + x, y - 8), colour
  LINE (x, y)-(x + 6, y - 8), colour
  LINE (26 + x, y - 9)-(x + 14, y - 13), colour, BF
  LINE (x + 24, y - 10)-(x + 24 + verdis, y - 10 - hordis), colour
EXIT SUB

tankl2:
  FOR I = x + 1 TO x + 27
    LINE (I + 5, y - 1)-(I, y - 7), colour
  NEXT I
  LINE (x + 5, y - 1)-(x, y - 7), colour
  FOR I = x + 5 TO x + 8
    LINE (I, y - 9)-(I + 4, y - 13), colour
  NEXT I

  FOR I = x + 18 TO x + 19
    LINE (I, y - 13)-(I + 3, y - 9), colour
  NEXT I

  LINE (x + 4, y - 8)-(8 + x, y - 13), colour
  LINE (8 + x, y - 13)-(18 + x, y - 13), colour
  LINE (18 + x, y - 13)-(21 + x, y - 8), colour
  LINE (x + 6, y)-(33 + x, y), colour
  LINE (x - 1, y - 8)-(6 + x, y), colour
  LINE (x - 1, y - 8)-(27 + x, y - 8), colour
  LINE (x + 27, y - 8)-(33 + x, y), colour
                                            

  LINE (9 + x, y - 13)-(20 + x, y - 9), colour, BF
  LINE (x + 9, y - 10)-(x + 9 - verdis, y - 10 + hordis), colour



END SUB

FUNCTION terrainpxltest (x AS INTEGER, y AS INTEGER) STATIC
  DIM pxlpoint AS INTEGER
  pxlpoint = POINT(x, y)
  IF pxlpoint = 2 OR pxlpoint = 6 THEN
    terrainpxltest = 1
  ELSE
    terrainpxltest = 0
  END IF
END FUNCTION

SUB winddraw (wind AS INTEGER)
  IF wind = 0 THEN
    CALL locatecol(1, 47, "No Wind", 4)
    EXIT SUB
  END IF
  IF wind > 0 THEN
    LINE (405, 8)-(404 + wind, 8), 4
    LINE (403 + wind, 8)-(401 + wind, 5), 4
    LINE (403 + wind, 8)-(401 + wind, 11), 4      '+1
    CALL locatecol(1, 47, "Wind", 4)
  ELSE
    LINE (466, 8)-(466 + wind, 8), 4
    LINE (466 + wind, 8)-(470 + wind, 5), 4
    LINE (466 + wind, 8)-(470 + wind, 11), 4   '-1
    CALL locatecol(1, 60, "Wind", 4)
  END IF
END SUB

FUNCTION windmake (maximumwind AS STRING)
  RANDOMIZE TIMER
  sign = INT(2 * RND + 1)
  IF sign = 2 THEN sign = -1
  SELECT CASE maximumwind
    CASE "no wind"
      windmke = 0
    CASE "gusty"
      windmke = INT(7 * RND)
      CASE "windy"
      windmke = INT(13 * RND)
    CASE "stormy"
      windmke = INT(20 * RND)
  END SELECT
    windmake = windmke * sign

END FUNCTION

